from bot_core.logging.database_logger import DatabaseLogger
from bot_data.abc.migration_abc import MigrationABC
from bot_data.db_context import DBContext


class AutoRoleMigration(MigrationABC):

    def __init__(self, logger: DatabaseLogger, db: DBContext):
        self._logger = logger
        self._db = db
        self._cursor = db.cursor

    def upgrade(self):
        self._logger.debug(__name__, 'Running upgrade')

        self._cursor.execute(
            str(f"""
            CREATE TABLE IF NOT EXISTS `AutoRoles` (
                `AutoRoleId` BIGINT NOT NULL AUTO_INCREMENT,
                `ServerId` BIGINT,
                `DiscordMessageId` BIGINT NOT NULL,
                `CreatedAt` DATETIME(6),
                `LastModifiedAt` DATETIME(6),
                PRIMARY KEY(`AutoRoleId`)
            );
            """)
        )

        self._cursor.execute(
            str(f"""
            CREATE TABLE IF NOT EXISTS `AutoRoleRules` (
                `AutoRoleRuleId` BIGINT NOT NULL AUTO_INCREMENT,
                `AutoRoleId` BIGINT,
                `DiscordEmojiId` BIGINT NOT NULL,
                `DiscordRoleId` BIGINT NOT NULL,
                `CreatedAt` DATETIME(6),
                `LastModifiedAt` DATETIME(6),
                PRIMARY KEY(`AutoRoleRuleId`)
            );
            """)
        )

    def downgrade(self):
        self._cursor.execute('DROP TABLE `AutoRole`;')
        self._cursor.execute('DROP TABLE `AutoRoleRules`;')
